local modId = "maikc_baureihe_52"

local hiddenFiles = {}
local function filterDoHideFiles(fileName, data)
	for i = 1, #hiddenFiles do
		if (string.ends(fileName, hiddenFiles[i])) then
			return false
		end
	end
	return true
end

local noStartYearFiles = {}
local noEndYearFiles = {}
local function modifierDoYears(fileName, data)
	for i = 1, #noStartYearFiles do
		if (string.ends(fileName, noStartYearFiles[i])) then
			data.metadata.availability.yearFrom = 0
		end
	end
	for i = 1, #noEndYearFiles do
		if (string.ends(fileName, noEndYearFiles[i])) then
			data.metadata.availability.yearTo = 0
		end
	end
	
	return data
end


--###########################################
local yearFiles = {
	"vehicle/train/maikc_br52_drg.mdl",
	"vehicle/train/maikc_br52_dr.mdl",	
	"vehicle/train/maikc_br52_dr2.mdl",
	"vehicle/train/maikc_br52_db.mdl",	
	"vehicle/train/maikc_br528_1.mdl",
	"vehicle/train/maikc_br528_2.mdl",
	"vehicle/train/maikc_br52_oebb_1.mdl",
	"vehicle/train/maikc_br52_oebb_2.mdl",
}
--###########################################


function data()
return {
	info = {
		minorVersion = 3,
		severityAdd = "NONE",
		severityRemove = "CRITICAL",
		name = _("br52_name"),
		description = _("br52_desc"),
		authors = {
			{
				name = "MaikC",
				role = "CREATOR",
				tfnetId = '21205'
			},
			{
				name = 'Skyjoe',
				role = 'CO-CREATOR',
				text = 'Textur',
				tfnetId = '23463'
			},
		},
		tags = { "europe", "railcar", "steam", "locomotive", },
			visible = true,
		-- Parameter für User-Ingame-Selection
			params = {
				{
					key = "maikc_br52_drg",
					name = _("vehicle_br52_drg_name_menu"),
					values = { _("Anzeigen"), _("Verstecken"), },
					tooltip = _("Die will ich ja/nein"),
					defaultIndex = 0,
				},
				{
					key = "maikc_br52_dr",
					name = _("vehicle_br52_dr_name_menu"),
					values = { _("Anzeigen"), _("Verstecken"), },
					tooltip = _("Die will ich ja/nein"),
					defaultIndex = 0,
				},	
				{
					key = "maikc_br52_dr2",
					name = _("vehicle_br52_dr2_name_menu"),
					values = { _("Anzeigen"), _("Verstecken"), },
					tooltip = _("Die will ich ja/nein"),
					defaultIndex = 0,
				},
				{
					key = "maikc_br52_db",
					name = _("vehicle_br52_db_name_menu"),
					values = { _("Anzeigen"), _("Verstecken"), },
					tooltip = _("Die will ich ja/nein"),
					defaultIndex = 0,
				},
				{
					key = "maikc_br528_1",
					name = _("vehicle_br528_1_name_menu"),
					values = { _("Anzeigen"), _("Verstecken"), },
					tooltip = _("Die will ich ja/nein"),
					defaultIndex = 0,
				},
				{
					key = "maikc_br528_2",
					name = _("vehicle_br528_2_name_menu"),
					values = { _("Anzeigen"), _("Verstecken"), },
					tooltip = _("Die will ich ja/nein"),
					defaultIndex = 0,
				},		
				{
					key = "maikc_br52_oebb_1",
					name = _("vehicle_br52_oebb_1_name_menu"),
					values = { _("Anzeigen"), _("Verstecken"), },
					tooltip = _("Die will ich ja/nein"),
					defaultIndex = 1,
				},
				{
					key = "maikc_br52_oebb_2",
					name = _("vehicle_br52_oebb_2_name_menu"),
					values = { _("Anzeigen"), _("Verstecken"), },
					tooltip = _("Die will ich ja/nein"),
					defaultIndex = 1,
				},
				{
					key = "maikc_br52_startyear",
					name = _("Verfügbarkeit / Startjahr"),
					values = { _("ab 1850"), _("Default"), },
					tooltip = _("Die will ich ja/nein"),
					defaultIndex = 1,
				},
				{
					key = "maikc_br52_endyear",
					name = _("Verfügbarkeit / Endjahr"),
					values = { _("Unendlich"), _("Default"), },
					tooltip = _("Die will ich ja/nein"),
					defaultIndex = 1,
				},
			},
		},
		
		runFn = function(settings, modParams)
			-- Mod-Parameter holen
			local params = modParams[getCurrentModId()]
			-- Wenn vorhanden....
			if params then
				if ((params.maikc_br52_drg or 0) == 1) then
					table.insert(hiddenFiles, "vehicle/train/maikc_br52_drg.mdl")
				end
				if ((params.maikc_br52_dr or 0) == 1) then
					table.insert(hiddenFiles, "vehicle/train/maikc_br52_dr.mdl")
				end		
				if ((params.maikc_br52_dr2 or 0) == 1) then
					table.insert(hiddenFiles, "vehicle/train/maikc_br52_dr2.mdl")
				end
				if ((params.maikc_br52_db or 0) == 1) then
					table.insert(hiddenFiles, "vehicle/train/maikc_br52_db.mdl")
				end		
				if ((params.maikc_br528_1 or 0) == 1) then
					table.insert(hiddenFiles, "vehicle/train/maikc_br528_1.mdl")
				end
				if ((params.maikc_br528_2 or 0) == 1) then
					table.insert(hiddenFiles, "vehicle/train/maikc_br528_2.mdl")
				end		
				if ((params.maikc_br52_oebb_1 or 0) == 1) then
					table.insert(hiddenFiles, "vehicle/train/maikc_br52_oebb_1.mdl")
				end	
				if ((params.maikc_br52_oebb_2 or 0) == 1) then
					table.insert(hiddenFiles, "vehicle/train/maikc_br52_oebb_2.mdl")
				end	
				
				-- Startjahr setzen
				if (params.maikc_br52_startyear or 0) == 0  then
					for i = 1, #yearFiles do
						table.insert(noStartYearFiles, yearFiles[i])
					end
				end
				-- Endjahr setzen
				if (params.maikc_br52_endyear or 0) == 0  then 
					for i = 1, #yearFiles do
						table.insert(noEndYearFiles, yearFiles[i])
					end
				end	
				
				-- Wenn Tabelle "hiddenFiles" nicht leer, FileFilter hinzufügen
				if (#hiddenFiles > 0) then
					addFileFilter("model/vehicle", filterDoHideFiles)
				end
				
				-- Modifier laden, falls Tabelle für "kein Endjahr" und/oder "kein Startjahr" nicht leer
				if ((#noEndYearFiles > 0) or (#noStartYearFiles > 0)) then
					addModifier("loadModel", modifierDoYears)
				end
			end

		end
 	}
end
